REM Check and modify all lines that begin with ***
REM REMOVE the *** characters once you have corrected or checked the line

REM @@Echo OFF
setlocal
***set homedir=E:\scripts\laptopcloud_createusers
***set bin=E:\scripts\bin
set counter=0

if not exist complete_users mkdir  %homedir%\new_users
if not exist complete_users mkdir  %homedir%\completed_users

@Echo %Date% %time% >> %homedir%\createuser.log
@Echo %Date% %time% CREATEUSER: STARTED >> %homedir%\createuser.log

***net use \\DATA_SERVER\SHARE PASSWORD /user:USERNAME
***robocopy "\\DATA_SERVER\SHARE\Users" "new_users" /S /E /COPYALL /LOG+:"%homedir%\robocopy.log" 
@Echo %Date% %time% ROBOCOPY returns: [%errorlevel%] >> %homedir%\createuser.log

***If not defined GALAXY_BASE set GALAXY_BASE=C:\INSTALL_FOLDER\SIMPANA\BASE
set PATH=%PATH%;%GALAXY_BASE%
***qlogin -u "YOUR USER"  -ps "YOUR PASSWORD"  -cs "YOUR COMMSERVER" 
If %errorlevel% NEQ 0 (
	@Echo %Date% %time% ERROR: Qlogin failed. errorlevel:[%errorlevel%] EXITING! >> %homedir%\createuser.log 
	exit /b /0)

dir /s /b %homedir%\new_users > %homedir%\dirs.txt
for /F "tokens=1* delims=>" %%a in (%homedir%\dirs.txt) do call :proccessuser "%%a"
goto end

:proccessuser
	@Echo %Date% %time% Processing file:[%1] >> %homedir%\createuser.log
	for /f "usebackq delims=; tokens=1-5" %%i in (%1) do (
		set UserID=%%i
		set Password=%%j
		set Email=%%k
		set Company=%%l
	)
	If exist %CD%\completed_users\%UserID%.txt (
		@Echo %Date% %time% SKIPPING USER:    [%UserID%] has already been processed...! >> %homedir%\createuser.log	
		del /Q %CD%\completed_users\%UserID%.txt
		goto :EOF
	) 
	@Echo %Date% %time%   ADDING USER: Got values: UserID=[%UserID%] Password=[%Password%] Email=[%Email%] Company=[%Company%] >> %homedir%\createuser.log 
	qcreate user -u "%UserID%" -p "%Password%" -fn "%UserID%" -desc Cloud_Laptop_User -e %Email%
	@Echo %Date% %time%   ADDING USER: Qcreate user command returned:[%errorlevel%] >> %homedir%\createuser.log 	
	If %errorlevel% EQU 0 (
		qoperation adduser -u "%UserID%" -ug "Laptop Users"
		@Echo %Date% %time%   ADDING USER: AddUser to group command returned:[%errorlevel%] >> %homedir%\createuser.log 
***		cscript %bin%\smtpmail.vbs //NOLOGO /from "YOUR_COMMSERVER@YOURCOMPANY.COM" /to %Email% /bcc "HELPDESK@YOURCOMPANY.COM" /subject "Your Username is now active" /body "Dear %UserID%,<br><br>Greetings from FOREVERCELL server at YOUR_COMPANY.<br><br> Your account %UserID% is now active on backup server.<br><br>You could use this account to register your laptop now.<br><br>Thank you.<br>YOUR_COMPANY Cloud Storage Team."
		move %1 "%CD%\completed_users\%userID%"
		del /Q \\DATA_SERVER\SHARE\Users\%userID%.txt
		@Echo %Date% %time%   del /Q \\DATA_SERVER\SHARE\Users\%userID%.txt  >> %homedir%\createuser.log 
		set /A counter=counter+1
	) else (
***		cscript %bin%\smtpmail.vbs //NOLOGO /from "YOUR_COMMSERVER@YOURCOMPANY.COM" /to "HELPDESK@YOURCOMPANY.COM" /subject "CloudLaptop Username creation FAILED for:[%UserID%] [end]"
	)	
	goto :EOF

:end
@Echo %Date% %time% DONE! [%counter%] users added >> %homedir%\createuser.log
***net use \\DATA_SERVER\SHARE /del
qlogout
if %errorlevel% NEQ 0 (@Echo %Date% %time% QLogout failed! >> %homedir%\createuser.log)
endlocal
